/*
 * $Id: livemanager.h,v 1.1.1.1 2002/03/14 14:19:26 kenta Exp $
 *
 * Copyright 2002 Kenta Cho. All rights reserved.
 */

/**
 * Speed Barricade live camera manager header file.
 *
 * @version $Revision: 1.1.1.1 $
 */

#define randN(N) (rand()%(N))
#define randNS(N) (rand()&1 ? (rand()%(N)) : -(rand()%(N)))

#define NOT_EXIST -999999999

typedef struct {
  int x1, y1, x2, y2;
  int downCnt;
} Wall;

#define WALL_MAX 24

typedef struct {
  int x, y, d, wallIdx;
  Wall wall[WALL_MAX];
} Motor;

typedef struct {
  int x, y, z;
  int mx, my, mz;
  int d1, d2, md1, md2;
  int cnt, size;
} Frag;

void initLive();
void setMotor(int mtrIdx, int wlIdx, int x, int y, int d);
void updateMotor(int mtrIdx, int wlIdx, int x, int y, int d);
void destroyWall(int mtrIdx, int wlIdx);
void crashMotor(int mtrIdx, int x, int y);
void deadMotor(int mtrIdx, int x, int y);
void resetGame();
void move();
void draw();
