/*
USBIO Support Program
Copyright (C) 2001 by Masahiro Sekiguchi, all rights reserved.

Redistribution and use in source and/or binary forms, with or without
modification, are permitted provided that the following conditions are
met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote
   products derived from this software.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
*/

/* Hacked substitute to <setupapi.h> to be used to compile usbio
   native code DLL.  This file is not intended to be a (part of)
   general purpose DDK replacement.  It exists only to allow compiling
   usbio native code DLL without licensing DDK from Microsoft.  */

/* DEFINES */

typedef struct dummy_HDEVINFO_struct const *HDEVINFO;

#define DIGCF_PRESENT           0x02
#define DIGCF_DEVICEINTERFACE   0x10

/* STRUCTURES */

#include "pshpack1.h"

typedef struct {
    DWORD cbSize;
    GUID ClassGuid;
    DWORD DevInst;
    ULONG_PTR Reserved;
}
    SP_DEVINFO_DATA,
    *PSP_DEVINFO_DATA;

typedef struct {
    DWORD cbSize;
    GUID InterfaceClassGuid;
    DWORD Flags;
    ULONG_PTR Reserved;
}
    SP_DEVICE_INTERFACE_DATA,
    *PSP_DEVICE_INTERFACE_DATA;

typedef struct {
    DWORD cbSize;
    CHAR DevicePath[1];
}
    SP_DEVICE_INTERFACE_DETAIL_DATA_A,
    *PSP_DEVICE_INTERFACE_DETAIL_DATA_A;

#include "poppack.h"

/* FUNCTIONS */

extern BOOL WINAPI
SetupDiDestroyDeviceInfoList (
    HDEVINFO DeviceInfoSet );

extern BOOL WINAPI
SetupDiEnumDeviceInterfaces (
    HDEVINFO DeviceInfoSet,
    PSP_DEVINFO_DATA DeviceInfoData,
    LPGUID InterfaceClassGuid,
    DWORD MemberIndex,
    PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData );

extern HDEVINFO WINAPI
SetupDiGetClassDevsA (
    LPGUID ClassGuid,
    PCSTR Enumerator,
    HWND hwndParent,
    DWORD Flags );

extern BOOL WINAPI
SetupDiGetDeviceInterfaceDetailA (
    HDEVINFO DeviceInfoSet,
    PSP_DEVICE_INTERFACE_DATA DeviceInterfaceData,
    PSP_DEVICE_INTERFACE_DETAIL_DATA_A DeviceInterfaceDetailData,
    DWORD DeviceInterfaceDetailDataSize,
    PDWORD RequiredSize,
    PSP_DEVINFO_DATA DeviceInfoData );


